from pytwss.mbean.mbean_utils import MBeanProxy
from pytwss.mbean.mbean_utils import Scope
from pytwss.mbean.mbean_utils import MAX_RETRIES
#
# The MBeanProxy to the ClusterMgr mbean.
#
class ClusterMgrAdministration(MBeanProxy):
	# Constructs a ClusterMgrAdministration object.
	# param: max_retries max retry count to connect to mbean
	def __init__(self, max_retries=MAX_RETRIES):
		scope = Scope(type='ClusterMgr')
		MBeanProxy.__init__(self, scope,
		                    max_retries=max_retries)	                 

#
# Gets the cluster members from the ClusterMgr mbean based on the cluster name.
# param: clusterName the name of the cluster
# return: the cluster members of the cluster
#
def getClusterMembers(clusterName):
	cmgr = ClusterMgrAdministration()
	clusterData = cmgr.retrieveCluster(clusterName)
	clusterMembers = []
	for clusterMember in clusterData.clusterMembers:
		APP_SERVER_TYPE = clusterMember.APP_SERVER
		memType = clusterMember.type
		memServerName = clusterMember.memberName
		if(memType == APP_SERVER_TYPE):
			clusterMembers.append(clusterMember)
	return clusterMembers
		
