from pytwss.mbean.mbean_utils import MBeanProxy, Scope, MAX_RETRIES, getAdminClient
from pytwss.utils import _, log, logScreen
import jarray, javax
import time, os, sys, os.path, shutil
from time import sleep
from java.lang import Boolean, System

#
# The MBeanProxy to the DeploymentManager mbean.
#
class DeploymentManagerAdministration(MBeanProxy):
    # Constructs a DeploymentManagerAdministration object.
    # param: nodeName the name of the node of the node agent.
    # param: max_retries max retry count to connect to mbean
    def __init__(self, node_name, cell_name, max_retries=MAX_RETRIES):
       scope = Scope(type='Server', process='dmgr', node=node_name, cell=cell_name)
       MBeanProxy.__init__(self, scope, max_retries=max_retries)

#
# Restarts a node agent using the DeploymentManager mbean.
# 
# param: nodeName the names of the node to restart
# param: cellName the names of the node to restart
# param: maxWait max time to wait for restart, default is 300 secs (5 minutes)
# return: the DeploymentManagerInfo
#
def restartDeploymentManager(nodeName, cellName, maxWait=300):

    nmgr = DeploymentManagerAdministration(nodeName, cellName)
    log("restart Deployment Manager at %s %s" %(cellName,nodeName))
    try:
       nmgr.restart()              # restart and don't wait
       log("restarting...")
    except:
       log('WARNING: %s %s %s %s' %(sys.exc_value, str(sys.exc_info()[0]), str(sys.exc_info()[1]), str(sys.exc_info()[2].dumpStack())))
       log("Please manually restart the dmgr or server instance.")

