from pytwss.mbean.mbean_utils import MBeanProxy
from pytwss.mbean.mbean_utils import Scope
from pytwss.mbean.mbean_utils import MAX_RETRIES
from pytwss.utils import _, log, logScreen
import jarray
from time import sleep
from java.lang import Boolean, System

#
# The MBeanProxy to the NodeSync mbean.
#
class NodeSyncAdministration(MBeanProxy):
    # Constructs a NodeSyncAdministration object.
    # param: nodeName the name of the node of the node agent.
    # param: max_retries max retry count to connect to mbean
    def __init__(self, node_name, max_retries=MAX_RETRIES):
       scope = Scope(type='NodeSync', node=node_name)
       MBeanProxy.__init__(self, scope, max_retries=max_retries)

#
# Syncs a node.
# 
# param: nodeName the names of the node to sync
# return: "true"
#
def syncNode(nodeName):
	
    is_synced_bool = "false"
    
    nsync = NodeSyncAdministration(nodeName)

    log("Synchronizing node agent: %s." % nodeName)
    logScreen(_("SOAC7538I") %{ '1' : nodeName })

    is_synced = nsync.sync()
    
    if is_synced == 1:
    	is_synced_bool = "true"
    	
    return is_synced_bool
 
 