#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2000, 2006
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

from pytwss.utils import _, log, boolToString

from javax.management import MBeanException

from com.ibm.twss.spm.admin.common import ServiceType
from com.ibm.twss.spm.admin.common import ServiceImplDefinition
from com.ibm.twss.spm.admin.common import ServiceDefinition
from com.ibm.twss.spm.admin.common import OperationDefinition
from com.ibm.twss.spm.admin.common import ScopedPolicies
from com.ibm.twss.spm.admin.common import ScopedPolicy
from com.ibm.twss.spm.admin.common import PolicyValue
from com.ibm.twss.spm.admin.common import PolicyType
import com.ibm.twss.spm.admin.svc.GetServiceImplementationsRequest \
	as SvcImplsReq
import com.ibm.twss.spm.admin.svc.CreateServiceImplementationRequest \
	as CrtImplReq
import com.ibm.twss.spm.admin.svc.CreateServiceRequest \
	as CrtSvcReq
import com.ibm.twss.spm.admin.svc.CreateOperationRequest \
	as CrtOpReq
import com.ibm.twss.spm.admin.policy.CreatePoliciesRequest \
	as CrtPolReq
import com.ibm.twss.spm.admin.type.CreatePolicyTypeRequest \
	as CrtTypeReq

from pytwss.mbean import spm_jython                     # NOTE: requires spm-runtime.jar to be in the -wsadmin_classpath
from pytwss.mbean import spm_mbean

class ServicePolicyAccess:
	def __init__(self):
           if spm_jython.isInitialized() == "true":
		self.ref = spm_jython.ServicePolicyAccess()
           else:
                self.ref = spm_mbean.ServicePolicyAccess()
        def getRef(self):
           return self.ref

class RequesterAdministration:
	def __init__(self):
           if spm_jython.isInitialized() == "true":
		self.ref = spm_jython.RequesterAdministration()
           else:
                self.ref = spm_mbean.RequesterAdministration()
        def getRef(self):
           return self.ref

class ServiceAdministration:
	def __init__(self):
           if spm_jython.isInitialized() == "true":
		self.ref = spm_jython.ServiceAdministration()
           else:
                self.ref = spm_mbean.ServiceAdministration()
        def getRef(self):
           return self.ref

class SubscriptionAdministration:
	def __init__(self):
           if spm_jython.isInitialized() == "true":
		self.ref = spm_jython.SubscriptionAdministration()
           else:
                self.ref = spm_mbean.SubscriptionAdministration()
        def getRef(self):
           return self.ref

class PolicyAdministration:
	def __init__(self):
           if spm_jython.isInitialized() == "true":
		self.ref = spm_jython.PolicyAdministration()
           else:
                self.ref = spm_mbean.PolicyAdministration()
        def getRef(self):
           return self.ref

class TypeAdministration:
	def __init__(self):
           if spm_jython.isInitialized() == "true":
		self.ref = spm_jython.TypeAdministration()
           else:
                self.ref = spm_mbean.TypeAdministration()
        def getRef(self):
           return self.ref

def registerServiceImplementation(svc_admin, svc_name, impl_name,
                                  enabled, desc):
        if spm_jython.isInitialized() == "true":
      	   return spm_jython.registerServiceImplementation(svc_admin.getRef(), svc_name, impl_name, enabled, desc)
        else:
           return spm_mbean.registerServiceImplementation(svc_admin.getRef(), svc_name, impl_name, enabled, desc)

def createPolicies(policy_admin, policies):
        if spm_jython.isInitialized() == "true":
           return spm_jython.createPolicies(policy_admin.getRef(), policies)
        else:
           return spm_mbean.createPolicies(policy_admin.getRef(), policies)

def registerPolicyType(type_admin, type_name, editable, edit_mask,
                       encrypted, desc):
        if spm_jython.isInitialized() == "true":
           return spm_jython.registerPolicyType(type_admin.getRef(), type_name, editable, edit_mask, encrypted, desc)
        else:
           return spm_mbean.registerPolicyType(type_admin.getRef(), type_name, editable, edit_mask, encrypted, desc)

# Service type constants
SERVICE = ServiceType.Service
SERVICE_GROUP = ServiceType.ServiceGroup

def createService(svc_admin, service, parent_group, enabled,
                  description, type):
	if spm_jython.isInitialized() == "true":
           return spm_jython.createService(svc_admin.getRef(), service, parent_group, enabled, description, type)
        else:
           return spm_mbean.createService(svc_admin.getRef(), service, parent_group, enabled, description, type)
           
def createOperation(svc_admin, service, operation, enabled,
                    description):
        if spm_jython.isInitialized() == "true":
           return spm_jython.createOperation(svc_admin.getRef(), service, operation, enabled, description)
        else:
           return spm_mbean.createOperation(svc_admin.getRef(), service, operation, enabled, description)
           
