#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2000, 2006
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

from java.util import Locale, ResourceBundle, MissingResourceException
from java.lang import ClassLoader, System, Runtime
from java.lang import String, Float
from java.util.concurrent.locks import ReentrantLock
from java.io import File, OutputStream, PrintStream, BufferedReader, InputStreamReader
import time, os, sys

__systemerr__ = System.err
__systemout__ = System.out
file_lock = ReentrantLock()

#
# class loader for loading resources
#
class PackageClassLoader(ClassLoader):
	"""Custom class loader for loading resources from the python
	package.

	This class loader is needed as a work around to wsadmin classpath
	issues on unix systems."""

	def __init__(self, base_path):
		ClassLoader.__init__(self)
		if not base_path:
			base_path = os.sep
		self.base_path = base_path

	def findResource(self, name):
		path_components = name.split('/')
		res_path = self.base_path + os.sep + os.sep.join(path_components)
		file = File(res_path)
		return file.toURL()

#
# Global initialization
#
import pytwss
lib_path = os.path.dirname(pytwss.__path__[0])
res_bundle = ResourceBundle.getBundle("pytwss/resources/Messages_SOAC",
	Locale.getDefault(), PackageClassLoader(lib_path))
logFile = None        

#
# boolean to string converter
#
def boolToString(boolean):
	"""Converts a boolean number to a printable boolean string."""
	if boolean:
		return "True"
	else:
		return "False"

#
# Global method for gettting text from a bundle
#
def getText(*input):
	"""Looks up the supplied input text in an internationalized bundle.

	For convenience, this method will combine arguments into a single
	string. This lets long strings be broken up into multiple, smaller
	strings, passed in as arguments."""
	input = ''.join(input)
        input2 = String(input).substring(0,8)
	try:
		intl_out = res_bundle.getString(input2)
		return intl_out
	except MissingResourceException, mre:
		return input + ": %s"

#
# global macro (ease of use substition) for getText
#
_ = getText 

#
#  Global setLogFile sets the file path to use for logging output
#
def setLogFile(logFilePath):
        if logFilePath:
           logFile = open(logFilePath, "a")
           sys.stdout = logFile
           sys.stderr = logFile
           System.setOut(PrintStream(LogOutputStream()))
           System.setErr(PrintStream(LogOutputStream()))
        else:
           sys.stdout = sys.__stdout__
           sys.stderr = sys.__stderr__
           System.setOut(__systemout__)
           System.setErr(__systemerr__)

#
# Log a line to the output
#
def log(output):
	"""Logs the output string to stdout, formatting the string with
	an ascii time stamp."""
        file_lock.lock()
	print "[%s] %s" %(time.asctime(), output)
        file_lock.unlock()

#
# Log a line to the screen
#
def logScreen(output):
	"""Logs the output string to stdout, formatting the string with
	an ascii time stamp."""
        file_lock.lock()
        keep = sys.stdout
        sys.stdout = sys.__stdout__
	print "[%s] %s" %(time.asctime(), output)
        sys.stdout = keep
        file_lock.unlock()

#
# LogOutputStream for intercepting System.out
#
class LogOutputStream(OutputStream):
   def close(self):
      return
   def flush(self):
      return
   #def write(self, ba):
   #   s = String(ba)
   #   log(s)
   #   return
   def write(self, ba, o, l):
      s = String(ba, o, l)
      log(s)
      return
   #def write(self, i):
   #   s = String(i)
   #   log(s)
   #   return
         
#
# Executes a Unix Command
# Returns the standard output.
# Throws exception if command fails.
def execUnixCmd(cmd):
   p = Runtime.getRuntime().exec(cmd)
   stdInput = BufferedReader(InputStreamReader(p.getInputStream()))
   stdError = BufferedReader(InputStreamReader(p.getErrorStream()))
   return_val = ""
   s = stdInput.readLine()
   while s:
      return_val = "" + s
      s = stdInput.readLine()
   return return_val

#
# Determines if a user is in a group based on name.
#
def hasGroupPrivileges(user_name, group_name):

   group_output =  execUnixCmd('groups %s' % user_name)
   group_str = group_output.split(':')[1].lstrip().rstrip()
   group_list = group_str.split(' ')
   
   rtn = 'false'
   for group in group_list:
      if(group == group_name):
         rtn = 'true'
   return rtn







